﻿# Product Requirements

- Visitors need to login first to view events.
- Visitors can browse a list of events, can filter by date ranges and channels [i.e. event tags/categories whatever you name it].
- Event list should grow naturally without user-noticing.
- Visitors can view event details, including title, descriptions, event photos, event date and location, people who have participated in, people who liked, and comments.
- Visitors can comment, like and participate in an event as well.

# Getting Started

## Setting up

1. Clone the Backend server [here](https://git.garena.com/isham.faizal/rn-entry-task-example-server).
1. Follow the _README.md_ to start the server
1. Clone the React Native Code [here](https://gitlab.com/eric.yangjw/black-cat.git).
1. Run “npm run ios” to start the application

## Navigating around

1. Enter the username and password

- Username: asd

Password: asd

- Upon authentication, a token will be received from the backend server. It is then stored in the AsyncStorage. When the user quits and re-opens the application, the application will check if there exists a token in the AsyncStorage.
  - If there is a token, it will use the token to authenticate the user and fetch the necessary data for the application
  - If there is no token, the user will be presented with the login page

1. Presented with Feed Page

- The Feed will be loaded with 20 events.
- When the user is reaching the bottom of the list, the application will fetch more event and have the infinite scroll effect

1. Search with search button on the left top corner

- User can filter by the date and channel
- Upon pressing the search button, the user will be presented with a filtered list of events.
- The user can then clear the filter criteria in the FilterHeader

1. View an event

- Users can tap into the event and view the details.
- The images in the event are horizontally scrollable
- The description box is expandable if the description is too long
- The like/going lists are expandable if there are too many likes/going
- When scrolling down the details, the action tab bar will highlight the corresponding section.
- Users can also tap on the action tab bar to jump to specific section
- Users can toggle the like/going in the bottom action bar.
- Users can comment by tapping on the comment button.
- Upon commenting, a toast will be displayed to indicate a commenting success.
- Users can also reply to the others by pressing the reply button

1. Go to Profile Page

- View the count of the liked/going/past
- Will scroll infinitely
- Each list will keep its original position

## Start Development

Refer to the codebase architecture and design in the following section

#

#

# Frontend Design

## Framework & Language Used

- React Native
- Redux
- TypeScript

## State Management

- Redux
- React.useState hook

## Linting

- ESLint & prettier for `pre-commit` hook.

#

# Frontend Architecture

## Navigation

The application contains 3 main navigators: AuthNavigator, AppNavigator and DrawerNavigator. Each navigator keeps its own navigation history. Therefore, the screens will not just be pushed on top of each other.

### AuthNavigator

The application listens to the _isLoggedIn_ state in the Redux store. Since the _isLoggedIn_ initial state is false, the AuthNavigator presents the LoginScreen to the user.

### AppNavigator

Upon successfully logged in, the _isLoggedIn_ state in the Redux store is changed to true. The AuthNavigator is replaced with the AppNavigator, which has access to the DrawerContent, FeedScreen, EventDetailsScreen and ProfileScreen.

### DrawerNavigator

Although the AppNavigator has access to the screens, only the DrawerNavigator has access to the DrawerContent. The DrawerNavigator maintains the navigation history between the FeedScreen and the DrawerContent.

## Redux

The diagram demonstrates the control flow of the Redux State Management of the application. The application will dispatch an _Action_. Redux-Thunk, a _middleware_ will be called to communicate with the backend to fetch the required date for the application. With the fetched data, the _reducer_ will “catch” the action and update the _store’s_ state.

### Redux Store

This diagram illustrates the breakdown of the _RootState_ and the properties stored in the smaller application state.

### Redux-Thunk

Basic Redux store only allows simple synchronous updates by dispatching an action. Middleware extends the store's abilities to write async logic that interacts with the store.

React-Thunk is used for basic Redux side effects logic, including complex synchronous logic that needs access to the store, and simple async logic like HTTP requests.

## Services

The diagram demonstrates the services the application uses. Each service corresponds to a Redux State and provides methods to make specific API requests based on the specific Redux Actions. The API calls are abstracted into services so that changes can be made easily when the API endpoints or requirement changes.

Within each service, if the API request requires any params or body, an interface is implemented to ensure that the developer will not miss out any required parameters.

Model

The model provides the structure of the object that developers can use.

Each model file consists of a JsonInterface and ObjectInterface. The JsonInterface ensures that the json we received are of the expected structure. The json object will then convert to an object with the Object interface, so the object can be used by developers in the code.

Each model file also consists of methods to convert json-to-object, object-to-json, json-list-to-object-list and object-list-to-json-list.

# Codebase Structure

#

The diagram illustrates how the files are organized. The more complex folder will be discussed below.

## Screen Folder

The screen folder consists of specific screen folders. Within each specific screen folder, there are the components folder, the redux folder and the screen.tsx file. The component folder will contain all the sub-components that build up the screen. The redux folder will contain actions and reducer files that are specific to the screen.

## Components Folder

The components contain common components that are used across multiple screens. For instance the HeaderComponent is used in more than 2 screens. It is placed in the components folder for other screens to import.

## Common Folder

The common folder will contain all the common files used by various files in the application.

# Testing

## Testing

- Setup Jest to test your React Native application.
- Write at least one snapshot test.
- Use react-test-renderer to test out the rendering logic for at least one React component.

#

# Backend API Design

The backend server used is the sample [rn-entry-task-example-server](https://git.garena.com/isham.faizal/rn-entry-task-example-server) provided.

This is the rough breakdown of each endpoints:

|                                                                                                                                                                     **Requests**                                                                                                                                                                      |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       **Reponse**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |                       **Error Status**                       |
| :---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | :----------------------------------------------------------: |
|                          <p>**Authentication**</p><p></p><p>**POST** /_auth/token_</p><p><br>body:</p><p>{</p><p>` `"username": string,</p><p>` `"password": string</p><p></p><p>}</p><p></p><p></p><p></p><p></p><p></p><p></p><p>Example:</p><p>{</p><p>` `"username": "asd",</p><p>` `"password":"asd"</p><p>}</p><p></p>                          |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              <p>data:</p><p>{</p><p>` `"token": string,</p><p>` `"user": {</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string,</p><p>` `"email": string,</p><p>` `"likes_count": number,</p><p>` `"goings_count": number,</p><p>` `"past_count": number</p><p>` `}</p><p>}</p><p></p><p></p><p></p><p>Example: </p><p>{</p><p>` `"token": "qwertyuiop",</p><p>` `"user": {</p><p>` `"id": 128,</p><p>` `"username": "John Smith",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=JohnSmith",</p><p>` `"email": "js@example.com",</p><p>` `"likes_count": 12,</p><p>` `"goings_count": 2,</p><p>` `"past_count": 3</p><p>` `}</p><p>}</p><p></p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |       <p>403</p><p>Incorrect username or password</p>        |
|                                                                                                                                           <p>**Retrieve All Channels**</p><p>**GET** /_channels_</p><p></p>                                                                                                                                           |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           <p>data:</p><p>{</p><p>` `"channels": [</p><p>` `{</p><p>` `"id": number,</p><p>` `"name": string</p><p>` `}</p><p>` `]</p><p>}</p><p></p><p></p><p>Example: </p><p>{</p><p>` `"channels": [</p><p>` `{</p><p>` `"id": 5,</p><p>` `"name": "Channel One"</p><p>` `},</p><p>` `{</p><p>` `"id": 6,</p><p>` `"name": "Park"</p><p>` `}</p><p>` `]</p><p>}</p><p></p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |                                                              |
|                                         <p>**Retrieve User Events**</p><p>**GET** _/user/**:userId**/events_</p><p></p><p>params:</p><p>{</p><p>` `type: string</p><p>` `offset: string</p><p>}</p><p></p><p>Example:</p><p>userId - 128</p><p>{</p><p>` `type: going</p><p>` `offset: 20</p><p>}</p><p></p>                                          | <p>data:</p><p>{</p><p>` `"events": [</p><p>` `{</p><p>` `"id": number,</p><p>` `"name": string,</p><p>` `"begin_time": number,</p><p>` `"end_time": number,</p><p>` `"description": string,</p><p>` `"creator": {</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `},</p><p>` `"create_time": number,</p><p>` `"update_time": number,</p><p>` `"channel": {</p><p>` `"id": number</p><p>` `"name": string</p><p>` `},</p><p>` `"goings": [</p><p>` `{</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `],</p><p>` `“likes”: [</p><p>` `{</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `],</p><p>` `“images” : [],</p><p>` `"location": string,</p><p>` `"goings_count": number,</p><p>` `"likes_count": number,</p><p>` `"is_going": boolean,</p><p>` `"is_liked": boolean, </p><p>` `“comments” : [</p><p>` `{</p><p>` `"id": number,</p><p>` `"create\_time": number,</p><p>` `"comment": string,</p><p>` `"author": {</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `},</p><p>` `],</p><p>` `},</p><p>` `{ … }</p><p>` `{ … }</p><p>` `],</p><p>` `“has_more”: boolean</p><p>}</p><p></p><p></p><p></p><p>Example:</p><p>{</p><p>` `"events": [</p><p>` `{</p><p>` `"id": 647,</p><p>` `"name": "Activity With ID 647",</p><p>` `"begin_time": 1585016580,</p><p>` `"end_time": 1585023780,</p><p>` `"description": "A text only!",</p><p>` `"creator": {</p><p>` `"id": 127,</p><p>` `"username": "John Smith",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=JohnSmith"</p><p>` `},</p><p>` `"create_time": 1577946980,</p><p>` `"update_time": 1577947980,</p><p>` `"channel": {</p><p>` `"id": 5,</p><p>` `"name": "Channel One"</p><p>` `},</p><p>` `"goings": [</p><p>` `{</p><p>` `"id": 24844,</p><p>` `"username": "user1",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=26224"</p><p>` `}</p><p>` `],</p><p>` `“likes”: [ ],</p><p>` `“images” : [],</p><p>` `"location": "KR\n10 Bayfront Ave",</p><p>` `"goings_count": 5,</p><p>` `"likes_count": 14,</p><p>` `"is_going": true,</p><p>` `"is_liked": true, </p><p>` `“comments” : [</p><p>` `{</p><p>` `"id": 81085,</p><p>` `"create\_time": 1582605380,</p><p>` `"comment": "coMMEnt",</p><p>` `"author": {</p><p>` `"id": 42256,</p><p>` `"username": "user",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=49511"</p><p>` `}</p><p>` `},</p><p>` `],</p><p>` `}</p><p>` `{ … }</p><p>` `{ … }</p><p>` `],</p><p>` `“has_more”: true</p><p>}</p> | <p>403</p><p>If the type param is not _liked/going/past_</p> |
| <p>**Retrieve All Events**</p><p>**GET** _/events_</p><p></p><p>params:</p><p>{</p><p>` `offset: number</p><p>` `channel: number</p><p>` `before: number</p><p>` `after: number</p><p>}</p><p></p><p></p><p></p><p></p><p>Example:</p><p>{</p><p>` `offset: 20</p><p>` `channel: 5</p><p>` `before: 1585567380</p><p>` `after: 1585567380</p><p>}</p> |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |                                                              |
|                                  <p>**Add Comment to Event**</p><p>**POST** _/event/**:id**/comments_</p><p></p><p>body:</p><p>{</p><p>` `"comment" : string</p><p>}</p><p></p><p></p><p></p><p></p><p></p><p></p><p></p><p></p><p></p><p>Example:</p><p>id - 800</p><p>{</p><p>` `"comment" : "message”</p><p>}</p>                                  |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        <p>data:</p><p>{</p><p>` `"comment": {</p><p>` `"id": number,</p><p>` `"create_time": number,</p><p>` `"comment": string,</p><p>` `"author": {</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `}</p><p>}</p><p></p><p></p><p>Example: </p><p>{</p><p>` `"comment": {</p><p>` `"id": 573717,</p><p>` `"create_time": 1623922313,</p><p>` `"comment": "This is a comment",</p><p>` `"author": {</p><p>` `"id": 128,</p><p>` `"username": "John Smith",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=JohnSmith"</p><p>` `}</p><p>` `}</p><p>}</p><p></p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |                                                              |
|                                                                                                                   <p>**Add Like to Event**</p><p>**POST** _/event/**:eventId**/likes_</p><p></p><p>Example:</p><p>eventId - 800</p>                                                                                                                   |                                                                                            <p>data: </p><p>` `{</p><p>` `"id": number,</p><p>` `"name": string,</p><p>` `"begin_time": number,</p><p>` `"end_time": number,</p><p>` `"description": string,</p><p>` `"creator": {</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `},</p><p>` `"create_time": number,</p><p>` `"update_time": number,</p><p>` `"channel": {</p><p>` `"id": number</p><p>` `"name": string</p><p>` `},</p><p>` `"goings": [</p><p>` `{</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `],</p><p>` `“likes”: [</p><p>` `{</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `],</p><p>` `“images” : [],</p><p>` `"location": string,</p><p>` `"goings_count": number,</p><p>` `"likes_count": number,</p><p>` `"is_going": boolean,</p><p>` `"is_liked": boolean, </p><p>` `“comments” : [</p><p>` `{</p><p>` `"id": number,</p><p>` `"create\_time": number,</p><p>` `"comment": string,</p><p>` `"author": {</p><p>` `"id": number,</p><p>` `"username": string,</p><p>` `"avatar": string</p><p>` `}</p><p>` `},</p><p>` `],</p><p>},</p><p></p><p></p><p></p><p></p><p>Example:</p><p>{</p><p>` `“event” : {</p><p>` `"id": 647,</p><p>` `"name": "Activity With ID 647",</p><p>` `"begin_time": 1585016580,</p><p>` `"end_time": 1585023780,</p><p>` `"description": "A text only!",</p><p>` `"creator": {</p><p>` `"id": 127,</p><p>` `"username": "John Smith",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=JohnSmith"</p><p>` `},</p><p>` `"create_time": 1577946980,</p><p>` `"update_time": 1577947980,</p><p>` `"channel": {</p><p>` `"id": 5,</p><p>` `"name": "Channel One"</p><p>` `},</p><p>` `"goings": [</p><p>` `{</p><p>` `"id": 24844,</p><p>` `"username": "user1",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=26224"</p><p>` `}</p><p>` `],</p><p>` `“likes”: [ ],</p><p>` `“images” : [],</p><p>` `"location": "KR\n10 Bayfront Ave",</p><p>` `"goings_count": 5,</p><p>` `"likes_count": 14,</p><p>` `"is_going": true,</p><p>` `"is_liked": true, </p><p>` `“comments” : [</p><p>` `{</p><p>` `"id": 81085,</p><p>` `"create\_time": 1582605380,</p><p>` `"comment": "coMMEnt",</p><p>` `"author": {</p><p>` `"id": 42256,</p><p>` `"username": "user",</p><p>` `"avatar": "http://i.pravatar.cc/300?u=49511"</p><p>` `}</p><p>` `},</p><p>` `],</p><p>` `}</p><p>}</p>                                                                                            |                                                              |
|                                                                                                               <p>**Add Going to Event**</p><p>**POST** _/event/**:eventId**/participants_</p><p></p><p>Example:</p><p>eventId - 800</p>                                                                                                               |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |                                                              |
|                                                                                                 <p>**Remove Like to Event**</p><p>**DEL** \*/event/**:eventId**/likes/**:userId\***</p><p></p><p>Example:</p><p>eventId - 800</p><p>userId - 128</p>                                                                                                  |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |                                                              |
|                                                                                              <p>**Remove Like to Event**</p><p>**DEL** \*/event/**:eventId**/participants/**:userId\***</p><p></p><p>Example:</p><p>eventId - 800</p><p>userId - 128</p>                                                                                              |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |                                                              |
